Attribute VB_Name = "GLOBAL"
'****************************************************************************
'*                                                                          *
'*   CMDemo-X.EXE Visual Basic Demo software, for use with CM110 or CM112   *
'*   Written in Microsoft Visual Basic 3.0 for Windows.                     *
'*                                                                          *
'****************************************************************************
'
'  Filename:  CMDemo-C.BAS
'  Development Filename:  CMDemo-B.BAS
'  Other Required Files:  All forms and other modules
'  File Rev: C
'
'  Copyright CVI Laser Corporation, 1996
'
'
'  Revision History:
'
'     Date      Rev  By     Desc. of Change/Modification
'     --------  ---  ---    --------------------------------------
'     xx-xx-96  A    TT     Created in VB 3.0
'
'     06-04-97  B    TT     Upgrade to VB 4.0, 16 bit version.
'                           Files changed CM11XV2.BAS, frmCM11x.
'                           (See ~2 for new codes)
'
'     08-12-02  C    TT     Upgraded to VB 6.0. This is V2.0a
'
'
'****************************************************************************

Option Explicit

' Softwave information
Global Const VERSION = "4"
Global Const REVISION = "10"        'in 10
Global Const HelpFile = "cm11x.hlp"

' Configuration information.
Global Const DefPort = 0    'The default port is com1; 2: com2 ...
Global Const DefBaud = 0    'The default baudrate is 9600;

' File Open/Save Dialog Flags
Global Const OFN_OVERWRITEPROMPT = &H2&
Global Const OFN_HIDEREADONLY = &H4&
Global Const OFN_FILEMUSTEXIST = &H1000&

' MsgBox parameters
Global Const MB_YESNO = 4
Global Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons
Global Const MB_ICONSTOP = 16          ' Critical message
Global Const MB_ICONQUESTION = 32      ' Warning query
Global Const MB_ICONEXCLAMATION = 48   ' Warning message
Global Const MB_ICONINFORMATION = 64   ' Information message

' Show parameters
Global Const MODAL = 1
Global Const MODELESS = 0

' MsgBox return values
Global Const IDOK = 1                  ' OK button pressed
Global Const IDCANCEL = 2              ' Cancel button pressed
Global Const IDABORT = 3               ' Abort button pressed
Global Const IDRETRY = 4               ' Retry button pressed
Global Const IDIGNORE = 5              ' Ignore button pressed
Global Const IDYES = 6                 ' Yes button pressed
Global Const IDNO = 7                  ' No button pressed
Global Const IDCONTINUE = 8            ' Continue button pressed

' Commands to pass WinHelp()
Global Const HELP_CONTEXT = &H1 '  Display topic in ulTopic
Global Const HELP_QUIT = &H2    '  Terminate help
Global Const HELP_INDEX = &H3   '  Display index
Global Const HELP_HELPONHELP = &H4      '  Display help on using help
Global Const HELP_SETINDEX = &H5        '  Set the current Index for multi index help
Global Const HELP_KEY = &H101           '  Display topic for keyword in offabData
Global Const HELP_MULTIKEY = &H201

' Window 3.1 commands to pass WinHelp()
Global Const HELP_CONTENTS = &H3     ' Display Help for a particular topic
Global Const HELP_SETCONTENTS = &H5  ' Display Help contents topic
Global Const HELP_CONTEXTPOPUP = &H8 ' Display Help topic in popup window
Global Const HELP_FORCEFILE = &H9    ' Ensure correct Help file is displayed
Global Const HELP_COMMAND = &H102    ' Execute Help macro
Global Const HELP_PARTIALKEY = &H105 ' Display topic found in keyword list
Global Const HELP_SETWINPOS = &H203  ' Display and position Help window

' Win Constants
Global Const WF_CPU286 = &H2&
Global Const WF_CPU386 = &H4&
Global Const WF_CPU486 = &H8&
Global Const WF_STANDARD = &H10&
Global Const WF_ENHANCED = &H20&
Global Const WF_80x87 = &H400&

' Win32
Public Const PROCESSOR_INTEL_386 = 386
Public Const PROCESSOR_INTEL_486 = 486
Public Const PROCESSOR_INTEL_PENTIUM = 586
Public Const PROCESSOR_MIPS_R4000 = 4000
Public Const PROCESSOR_ALPHA_21064 = 21064

' Global varables
Global gblCancel%   'True or False
Global Serial&
Global gblInitCom%
Global gblOkCancel%, gblContinueCancel%
Global gblOrder%, gblUnitToNm!
Global gblNGrtSelted&   'Number of grating selected.
Global gblUnits$, gblUnitsN%, gblCurWL&, gblCurGr&, gblCurBl&
Global gblBaud%, gblPortNo%
Global gblSSpeed%, gblCurSize%
Global gblType% '0: single, 1: Additive dispersion, 254: Subtractive dps.
Global gblIniExist% 'True: if cm11x.ini exists.
Global gblAddr%, gblOVal%, gblNVal%

Type MEMORYSTATUS   '  32 Bytes
        dwLength As Long
        dwMemoryLoad As Long
        dwTotalPhys As Long
        dwAvailPhys As Long
        dwTotalPageFile As Long
        dwAvailPageFile As Long
        dwTotalVirtual As Long
        dwAvailVirtual As Long
End Type

Type SYSTEM_INFO  '  36  Bytes
        dwOemID As Long
        dwPageSize As Long
        lpMinimumApplicationAddress As Long
        lpMaximumApplicationAddress As Long
        dwActiveProcessorMask As Long
        dwNumberOrfProcessors As Long
        dwProcessorType As Long
        dwAllocationGranularity As Long
        wProcessorLevel As Integer
        wProcessorRevision As Integer
End Type

' DLL's declarations
Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hwnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long
'Declare Function WinHelp Lib "user32" (ByVal hwnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, ByVal dwData As Any) As Integer
Declare Function GetPrivateProfileInt& Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String)
Declare Function WritePrivateProfileString& Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As String, ByVal lpFileName As String)
Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)
Declare Sub GetSystemInfo Lib "kernel32" (lpSystemInfo As SYSTEM_INFO)


    ' DLL's declarations
'Declare Function WinHelp Lib "User" (ByVal hWnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, ByVal dwData As Any) As Integer
'Declare Function GetFreeSpace Lib "Kernel" (ByVal wFlags As Integer) As Long
'Declare Function GetFreeSystemResources Lib "User" (ByVal fuSysResource As Integer) As Integer
'Declare Function GetWinFlags Lib "Kernel" () As Long
'Declare Function GetPrivateProfileInt Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Integer, ByVal lpFileName As String) As Integer
'//Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFilename As String) As Integer
'Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, lpKeyName As Any, ByVal lpString As String, ByVal lplFileName As String) As Integer


Sub Centerform(X As Form)
  X.Top = Screen.Height / 2 - X.Height / 2
  X.Left = Screen.Width / 2 - X.Width / 2
End Sub

Function COMInit%(PortNo%, Baudrate%)
 'Returns true if success; otherwise this function returns false.
  Dim Status%, BaudLocal%, PortLocal%
  ' Remember: will get portnumber, and baudrate.
  On Error GoTo COMInitErr
  PortLocal% = PortNo% + 1
  BaudLocal% = 9600 / 2 ^ Baudrate%
  Status% = CMInitComPort%(PortLocal%, BaudLocal%, frmCM11x.comComm1)
  If Status% > 127 Then
    'An error has occurred.
    COMInit% = False
  Else
    COMInit% = COMTest%()
  End If
COMInitResume:
  Exit Function

COMInitErr:
  MsgBox "Error code is : " & Err, MB_ICONEXCLAMATION, "Init. Comm. Port Error"
  Resume COMInitResume

End Function

Function COMTest%()
  'Returns true if success; otherwise this function returns false.
  Dim Status%
  On Error GoTo COMTestErr
  'MsgBox "Sending :  27 ", MB_ICONINFORMATION, "Init. Comm. Port"
  Status% = CMEcho%(frmCM11x.comComm1, 1)   '1: is Timeout% in seconds
  If Status% > 127 Then
    MsgBox "The monochromator is not responding ", MB_ICONQUESTION, "Init. Comm. Port"
    gblInitCom% = False
    COMTest% = False
  Else
    gblInitCom% = True
    COMTest% = True
  End If

COMTestResume:
  Exit Function

COMTestErr:
  MsgBox "Error code is : " & Err, MB_ICONEXCLAMATION, "Init. Comm. Port Error"
  Resume COMTestResume

End Function

Function GetCmInit%()
' If cm11x.ini doesn't exist, then this function will return False;
' otherwise, it will return true.
  Dim subPort%, subBaud%
  Dim Ret%
  
  subPort% = GetPrivateProfileInt("CM11X", "Port", -1, "cm11x.ini")
  If subPort% = -1 Then
    GetCmInit% = False
  Else
    GetCmInit% = True
    subBaud% = GetPrivateProfileInt("CM11X", "Baud", -1, "cm11x.ini")
    gblPortNo% = subPort%
    gblBaud% = subBaud%
  End If

End Function

Sub InitQueries()
  Dim DataByte&, Status%, Timeout%
  Timeout% = 2 * 2 ^ gblBaud%

  ' Query current wavelength
  Status% = CMQuery%(0, DataByte&, frmCM11x.comComm1, Timeout%) '5: 5s Timeout%
  If Status% > 127 Then GoTo ErrMessage
    gblCurWL& = DataByte&
  ' Query current unit
  Status% = CMQuery%(14, DataByte&, frmCM11x.comComm1, Timeout%) '5: 5s Timeout%
  If Status% > 127 Then GoTo ErrMessage
    gblUnitsN% = DataByte&
    Select Case DataByte&
      Case 0
        gblUnits$ = "centi-Microns"
        gblUnitToNm! = 10
      Case 1
        gblUnits$ = "Nanometers"
        gblUnitToNm! = 1
      Case 2
        gblUnits$ = "Angstroms"
        gblUnitToNm! = 0.1
      End Select
  'Query the machine serial number.
  Status% = CMQuery%(19, DataByte&, frmCM11x.comComm1, Timeout%) '5: 5s Timeout%
  
  If Status% > 127 Then GoTo ErrMessage
  Serial& = DataByte&
  'Query the type of the machine
  '0: single, 1: Additive dispersion, 254: Subtractive dps.
  Status% = CMQuery%(1, DataByte&, frmCM11x.comComm1, Timeout%) '5: 5s Timeout%
  
  If Status% > 127 Then GoTo ErrMessage
  gblType% = DataByte&
  'Query the current grating groove.
  Status% = CMQuery%(2, DataByte&, frmCM11x.comComm1, Timeout%) '5: 5s Timeout%
  
  If Status% > 127 Then GoTo ErrMessage
  gblCurGr& = DataByte&
  'Query current grating blaze.
  Status% = CMQuery%(3, DataByte&, frmCM11x.comComm1, Timeout%) '5: 5s Timeout%
  
  If Status% > 127 Then GoTo ErrMessage
  gblCurBl& = DataByte&
  'Query the # of grating selected
  Status% = CMQuery%(4, DataByte&, frmCM11x.comComm1, Timeout%) '5: 5s Timeout%
  If Status% > 127 Then GoTo ErrMessage
  
  gblNGrtSelted& = DataByte&
  'Extract the current order from bit 3 of Status% byte
  gblOrder% = (Status% And 8) \ 8
  'Query the current scan speed.
  Status% = CMQuery%(5, DataByte&, frmCM11x.comComm1, Timeout%) '5: 5s Timeout%

  If Status% > 127 Then GoTo ErrMessage
  gblSSpeed% = DataByte&
  'Query the current size.
  Status% = CMQuery%(6, DataByte&, frmCM11x.comComm1, Timeout%) '5: 5s Timeout%

  If Status% > 127 Then GoTo ErrMessage
  gblCurSize% = DataByte&
  Exit Sub

ErrMessage:
  MsgBox "An error has occurred !", MB_ICONSTOP

End Sub

Function SaveCmInit%()
' This function returns true if it is succeful.
' Otherwise, it is false.
  Dim subPort%, subBaud%
  Dim Ret1%, Ret2%
  subPort% = gblPortNo%
  subBaud% = gblBaud%
  Ret1% = WritePrivateProfileString("CM11X", ByVal "Port", Str$(subPort%), "cm11x.ini")
  Ret2% = WritePrivateProfileString("CM11X", ByVal "Baud", Str$(subBaud%), "cm11x.ini")
  If Ret1% = 0 Or Ret2% = 0 Then
    SaveCmInit% = False
  Else
    SaveCmInit% = True
  End If

End Function

Sub SaveConfig()
  Dim Baud$
  If gblInitCom% Then
    If SaveCmInit%() Then
      Baud$ = Str$(9600 / (2 ^ gblBaud%))
      MsgBox "COM " & gblPortNo% + 1 & " and " & Baud$ & " Baud rate have been saved. "
    Else
      MsgBox "An error has occurred. The current configuration cannot be saved. "
    End If
  Else
    MsgBox "Did you initialize a serial port ? "
  End If

End Sub

Sub TopLeftform(X As Form)
  X.Top = 0
  X.Left = 0

End Sub

